using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using RegularLanguages;

namespace RegularLanguages
{
    public partial class LanguageWizardForm : Form
    {
        public LanguageWizardForm(Alphabet<char> alphabet)
        {
            InitializeComponent();
            this.alphabet = alphabet;
            this.language = null;
        }

        public ILanguage<char> Language
        {
            get
            {
                return this.language;
            }
        }

        private Alphabet<char> alphabet;
        private ILanguage<char> language;

        private void nextButton_Click(object sender, EventArgs e)
        {
            Form languageForm = null;
            if (dfaRadioButton.Checked)
                languageForm = new DFAModelerForm(this.alphabet);
            else if (lstarRadioButton.Checked)
                languageForm = new LStarForm(this.alphabet);
            else if (rpniRadioButton.Checked)
                languageForm = new RPNIForm(this.alphabet);
            else if (regexRadioButton.Checked)
                languageForm = new RegexForm(this.alphabet);
            else if (sltRadioButton.Checked)
                languageForm = new SLTForm(this.alphabet, 1);
            DialogResult dialogResult = languageForm.ShowDialog();
            if (dialogResult == DialogResult.OK)
            {
                if (languageForm is LanguageForm<char>)
                    this.language = (languageForm as LanguageForm<char>).Language;
                this.DialogResult = DialogResult.OK;
                this.Close();
            }
            else this.language = null;
        }
    }
}